/*
 * Copyright (c) 2015 Tricoire Sebastien 3dsman@free.fr
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 */

#pragma once

#include "actions/OE_actions.h"
#include "stitchs/OE_linkstitch.h"

class OE_actionAddPointLinkStitch : public OE_actions
{
	public:
		OE_actionAddPointLinkStitch(OE_document* doc, OE_linkstitch* stitch, int _pos, vector_2d _point);

		virtual ~OE_actionAddPointLinkStitch();

		virtual void undo();
		virtual void redo();

		void setOffset(vector_2d _offset);

	protected:
		OE_linkstitch* actionStitch;
		vector_2d point;
		vector_2d offset;
		int pos;
};

class OE_actionMovePointLinkStitch : public OE_actions
{
	public:
		OE_actionMovePointLinkStitch(OE_document* doc, OE_linkstitch* stitch, int _pos, vector_2d _offet);

		virtual ~OE_actionMovePointLinkStitch();

		virtual void undo();
		virtual void redo();

		void setOffset(vector_2d offset);

	protected:
		OE_linkstitch* actionStitch;
		vector_2d oldPoint;
		vector_2d offset;
		int pos;
};

class OE_actionDelPointLinkStitch : public OE_actions
{
	public:
		OE_actionDelPointLinkStitch(OE_document* doc, OE_linkstitch* stitch, int _pos);

		virtual ~OE_actionDelPointLinkStitch();

		virtual void undo();
		virtual void redo();

	protected:
		OE_linkstitch* actionStitch;
		vector_2d point;
		int pos;
};

